unit FMainGPX;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, ShellAPI,
  Provider, OleCtrls, SHDocVw, ImgList, ActnList, Buttons,
  UProcedures;

type


  TFormMain = class(TForm)
    PanelInf: TPanel;
    Panel2: TPanel;
    OpenDialog1: TOpenDialog;
    PageControl1: TPageControl;
    tsMap: TTabSheet;
    PanelCentral: TPanel;
    pnlExpandirColapsar: TPanel;
    lblBarra: TLabel;
    pnl1: TPanel;
    img1: TImage;
    pnlMapa: TPanel;
    wbMapaGoogle: TWebBrowser;
    pnlPos: TPanel;
    Image2: TImage;
    ImageList1: TImageList;
    btnCargar: TBitBtn;
    Label1: TLabel;
    rgProviderMap: TRadioGroup;
    StatusBar1: TStatusBar;
    procedure btnCerrarClick(Sender: TObject);
    procedure wbMapaGoogleDocumentComplete(ASender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnCargarClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure rgProviderMapClick(Sender: TObject);
    procedure StatusBar1Click(Sender: TObject);
  private
    DoneVisualization: Boolean;
    TSPoints: TStrings;
    TS1, TS2, TS3:TStrings;
    actualProvider:TProviderMap;

    procedure _CenterPanel(APanel: TPanel);
  public
    { Public declarations }
  end;

const
  CHAR_COMMA = ',';
  CHAR_POINT = '.';

var
  FormMain: TFormMain;

  // =========================================================================
  //
  // I N T E R F A C E
  //
  // =========================================================================
implementation

{$R *.dfm}

uses
  StrUtils,
  UConstantes,
  MSHTML;

procedure TFormMain.btnCerrarClick(Sender: TObject);
begin Self.Close;

end;

procedure TFormMain.Button1Click(Sender: TObject);

begin
  // Note there are spaces in the string.

end;

procedure TFormMain.FormCreate(Sender: TObject);
begin
  // iNi
  // DoneVisualization := False;
  DecimalSeparator := ',';

  TS1 := TStringList.Create();
  TS2 := TStringList.Create();
  TS3 := TStringList.Create();

end;

procedure TFormMain.FormShow(Sender: TObject);
begin
  // DoneVisualization := True;

MessageDlg('Algunos de los mapas que se utilizan en este ejemplo requieren de registrar una KEY (gratuta). '+#13+#10+''+#13+#10+'Google: https://developers.google.com/maps/signup?hl=es'+#13+#10+'Microsoft: http://www.microsoft.com/maps/developers/web.aspx'+#13+#10+''+#13+#10+'Ruego que si alguien va a desarrollar aplicaciones a partir de estos ejemplos solicite la suya personal y no utilice las de los ejemplos. '+#13+#10+'Igualmente mi intencin es darlas de baja en un breve espacio de tiempo.'+#13+#10+''+#13+#10+'Un saludo.'+#13+#10+''+#13+#10+'Gracias.', mtWarning, [mbOK], 0);

end;

procedure TFormMain.btnCargarClick(Sender: TObject);
var
  ind: integer;
  StrLat, StrLon, StrLine: string;
  b:Boolean;
  j,k, points:integer;
  flag, cargar:Boolean;
begin

  // Se ha pulsado el boton?
  if Assigned(Sender) or (not FileExists(OpenDialog1.FileName))then begin
    // Abrir el dialogo
    b := OpenDialog1.Execute;
    cargar := False;

    // Nada seleccionado?
    if (not b) then begin
      Exit;
    end;
  end;

  // ini
  TS1{Memo1.Lines}.Clear;
  TS2{Memo2.Lines}.Clear;
  TS3{Memo3.Lines}.Clear;


  {Memo1.Lines}TS1.LoadFromFile(OpenDialog1.FileName);
  k := Pos('<coordinates>', TS1.Text);
  TS1.Text := Copy(TS1.Text, k, Length(TS1.Text));
  k := Pos('</coordinates>', TS1.Text);
  TS1.Text := Copy(TS1.Text, 1, k + Length('</coordinates>')-1);

  TS1.Text := AnsiReplaceText(TS1.Text, '<coordinates>', '<coordinates>'#13#10);
  TS1.Text := AnsiReplaceText(TS1.Text, ' ', #13#10);
//-debug-  TS1.SaveToFile('r:\coord.txt');

  // Cargar el fichero KML
  //  {Memo1.Lines}TS1.LoadFromFile(OpenDialog1.FileName);
  ind := 0;
  flag := False;
  // Extraer las lneas de coordenadas
  while (not flag) do begin
    StrLine := {Memo1.Lines}TS1[ind];
    // Empiezan las coordenadas
    if (AnsiPos('<coordinates>', Trim(StrLine)) <> 0) then begin
      // comenzar a leer coordenadas
      cargar := True;
    end
    else if (AnsiPos('</coordinates>', Trim(StrLine)) <> 0) then begin
      // acabamos
      cargar := False;
      flag := True;
    end
    else begin
      if (cargar) then begin
        {Memo2.Lines}TS2.Add(Trim(StrLine));
      end;
    end;

    // incrementar el indice
    Inc(ind);
  end; // while

  points := 0;

  // Generar los datos para la pgina web
  for j := 0 to ({Memo2.Lines}TS2.count - 1) do begin

    // Extraer LATITUD
    StrLine := {Memo2.Lines}TS2[j];

    // Tiene algo?
    if (StrLine <> '') then begin
      k := Pos(',', StrLine);
      StrLat := Copy(StrLine, 1, k-1);

      // EXtraer LONGITUD
      StrLine := Copy(StrLine, k+1, Length(StrLine));
      k := Pos(',', StrLine);
      StrLon := Copy(StrLine, 1, k-1);
      
      // Segun el tipo de mapa...
   	  if (pmtOpenStreetMap = TProviderMap(rgProviderMap.ItemIndex)) then begin
        TS3.Add(Format('points[%d] =new OpenLayers.LonLat(%s,%s).transform(new OpenLayers.Projection("EPSG:4326"), map.getProjectionObject());;',
                      [points, StrLat, StrLon]));
        TS3.Add(Format('points[%d] = new OpenLayers.Geometry.Point(points[%d].lon,points[%d].lat);',[points,points,points]));
  	  end
      else if (pmtGoogle = TProviderMap(rgProviderMap.ItemIndex)) then begin
        if (points = 0) then begin
          // Aadir
          TS3.Add('new GLatLng(' + StrLon + ',' + StrLat + ')');
        end
        else begin
          TS3.Add(',new GLatLng(' + StrLon + ',' + StrLat + ')');
        end;
      end
      else begin
        if (points = 0) then begin
          // Aadir
          TS3.Add(Format('         new MM.Location(%s,%s)',[StrLon, StrLat]));
        end
        else begin
          TS3.Add(Format('         ,new MM.Location(%s,%s)',[StrLon, StrLat]));
        end;
      end;

      // incrementar los puntos dibujados
      Inc(points);

    end;
  end;

  // VISUALIZAR
  PageControl1.ActivePage := tsMap;
  pnlPos.Visible := True;
  _CenterPanel(pnlPos);
  pnlPos.BringToFront;
  PanelCentral.Visible := True;
  PanelCentral.Align := alClient;
  wbMapaGoogle.Visible := True;

  // StrLat := FloatToStr(latCenter);
  StrLat := STR_EMPTY;{AnsiReplaceText(StrLat, CHAR_COMMA, CHAR_POINT)};

  // StrLon := FloatToStr(lonCenter);
  StrLon := STR_EMPTY{AnsiReplaceText(StrLon, CHAR_COMMA, CHAR_POINT)};

  // Visualizar
  actualProvider := TProviderMap(rgProviderMap.ItemIndex);
  VisualizarMapa(TProviderMap(rgProviderMap.ItemIndex), wbMapaGoogle,
                 StrLat, StrLon, pnlMapa.Height,
                 pnlMapa.Width, 1, G_NORMAL_MAP, {Memo3.Lines}TS3.text);


end;

procedure TFormMain.wbMapaGoogleDocumentComplete(ASender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
var
  Doc: IHTMLDocument2; // current HTML document
begin

  // panel
  pnlPos.Visible := False;
  Application.ProcessMessages;

  // ocultar barras de desplazamiento
  Doc := wbMapaGoogle.Document as IHTMLDocument2;
  Doc.Body.Style.overflow := 'hidden';
  // Completada la carga
  DoneVisualization := True;
  TSPoints := nil;
end;


procedure TFormMain._CenterPanel(APanel: TPanel);
begin
  if (APanel.Parent is TWinControl) then begin
      APanel.Left := (TWinControl(APanel.Parent).Width - APanel.Width) Div 2;
    APanel.Top := (TWinControl(APanel.Parent).Height - APanel.Height) Div 2;
  end;
end;

procedure TFormMain.rgProviderMapClick(Sender: TObject);
begin
  // No ha cambiado el tipo de Mapa?
  if (actualProvider = TProviderMap(rgProviderMap.ItemIndex)) then begin
    Exit;
  end;
  // Visualizar
  Self.btnCargarClick(nil);

//  actualProvider := TProviderMap(rgProviderMap.ItemIndex);
//  VisualizarMapa(TProviderMap(rgProviderMap.ItemIndex), wbMapaGoogle,
//                 STR_EMPTY, STR_EMPTY, pnlMapa.Height,
//                 pnlMapa.Width, 1, G_NORMAL_MAP, {Memo3.Lines}TS3.text);

end;

procedure TFormMain.StatusBar1Click(Sender: TObject);
begin
  ShellExecute(0, 'open', PChar('http://neftali.clubdelphi.com'), nil, nil, SW_SHOWNORMAL);
end;

end.
